/******************************************************************************/
/*                                                                            */
/*                  LCD   HD44780                  */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*     4-  .               */
/*                                                  */
/*                                                                            */
/******************************************************************************/

//#include <inttypes.h>
#include <avr/io.h>
//#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdlib.h>
#include "lcd.h"



#define LCD_PORT PORTA //   LCD 
#define LCD_DDR DDRA //   LCD 
#define LCD_E 4 //    
#define LCD_RS 5 // /
#define LCD_RW 6 // /


#define CMD_4BIT     0b00101000   //   4- 
#define CMD_CLRSCR   1 //   
#define CMD_SCR_PARAM 0b00001100 //  ,  
#define CMD_SHIFT 0b00010100 //    
 


void lcd_command(unsigned char cmd)
{
  LCD_PORT = (cmd & 0x0f) | (1 << LCD_E);
  _delay_us(500);
  LCD_PORT &= ~(1 << LCD_E);
  _delay_us(500); 
}



void lcd_command4(unsigned char cmd)
{
   lcd_command(cmd >> 4); //  
   lcd_command(cmd); //   

}


//   4-    LCD
void lcd_Set4bit()
{
  lcd_command(0b00000011); 
  lcd_command(0b00000011); 
  lcd_command(0b00000010); 
  lcd_command4(CMD_4BIT);
  lcd_command4(CMD_SCR_PARAM);

 

}



//   
void lcd_init(void)
{
  _delay_ms(30); 
  LCD_DDR = 0b11111111; //   
  LCD_PORT = 0; 
  lcd_Set4bit(); //  4-x  



}

void lcd_data(char Ch)
{
  LCD_PORT = (Ch >> 4) | (1 << LCD_E) | (1 << LCD_RS);
  _delay_us(500);
  LCD_PORT = (Ch >> 4) | (1 << LCD_RS);
  _delay_us(500);
  LCD_PORT = (Ch & 0x0f) | (1 << LCD_E) | (1 << LCD_RS);
  _delay_us(500);
  LCD_PORT = (Ch & 0x0f) | (1 << LCD_RS);
  _delay_us(500);

}




void lcd_printI(unsigned long val)
{
  char buffer[16];
  ltoa(val, buffer, 10);
  int i = 0;
  while (buffer[i++] != 0); //   
  i = 13 - i;
  
  lcd_command4(CMD_CLRSCR);
  while (i-- != 0) lcd_command4(CMD_SHIFT); 
  i = 0;
  while (buffer[i] != 0)
  {
     lcd_data(buffer[i++]);

  }


}






 
