
;==========================================================================
;    
;      
;==========================================================================
        LIST         P=16F628A
;		#include p16f628a.inc  




;===========================================================================================================
;
;       Register Definitions
;
;==========================================================================

W                            EQU     H'0000'
F                            EQU     H'0001'

;----- Register Files------------------------------------------------------

INDF                         EQU     H'0000'
TMR0                         EQU     H'0001'
PCL                          EQU     H'0002'
STATUS                       EQU     H'0003'
FSR                          EQU     H'0004'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
PCLATH                       EQU     H'000A'
INTCON                       EQU     H'000B'
PIR1                         EQU     H'000C'
TMR1L                        EQU     H'000E'
TMR1H                        EQU     H'000F'
T1CON                        EQU     H'0010'
TMR2                         EQU     H'0011'
T2CON                        EQU     H'0012'
CCPR1L                       EQU     H'0015'
CCPR1H                       EQU     H'0016'
CCP1CON                      EQU     H'0017'
RCSTA                        EQU     H'0018'
TXREG                        EQU     H'0019'
RCREG                        EQU     H'001A'
CMCON                        EQU     H'001F'

OPTION_REG                   EQU     H'0081'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'
PIE1                         EQU     H'008C'
PCON                         EQU     H'008E'
PR2                          EQU     H'0092'
TXSTA                        EQU     H'0098'
SPBRG                        EQU     H'0099'
EEDATA                       EQU     H'009A'
EEADR                        EQU     H'009B'
EECON1                       EQU     H'009C'
EECON2                       EQU     H'009D'
VRCON                        EQU     H'009F'

;----- STATUS Bits --------------------------------------------------------

IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'

;----- INTCON Bits --------------------------------------------------------

GIE                          EQU     H'0007'
PEIE                         EQU     H'0006'
T0IE                         EQU     H'0005'
INTE                         EQU     H'0004'
RBIE                         EQU     H'0003'
T0IF                         EQU     H'0002'
INTF                         EQU     H'0001'
RBIF                         EQU     H'0000'

;----- PIR1 Bits ----------------------------------------------------------

EEIF                         EQU     H'0007'
CMIF                         EQU     H'0006'
RCIF                         EQU     H'0005'
TXIF                         EQU     H'0004'
CCP1IF                       EQU     H'0002'
TMR2IF                       EQU     H'0001'
TMR1IF                       EQU     H'0000'

;----- T1CON Bits ---------------------------------------------------------
T1CKPS1                      EQU     H'0005'
T1CKPS0                      EQU     H'0004'
T1OSCEN                      EQU     H'0003'
NOT_T1SYNC                   EQU     H'0002'
TMR1CS                       EQU     H'0001'
TMR1ON                       EQU     H'0000'

;----- T2CON Bits ---------------------------------------------------------
TOUTPS3                      EQU     H'0006'
TOUTPS2                      EQU     H'0005'
TOUTPS1                      EQU     H'0004'
TOUTPS0                      EQU     H'0003'
TMR2ON                       EQU     H'0002'
T2CKPS1                      EQU     H'0001'
T2CKPS0                      EQU     H'0000'

;----- CCP1CON Bits ---------------------------------------------------------
CCP1X                        EQU     H'0005'
CCP1Y                        EQU     H'0004'
CCP1M3                       EQU     H'0003'
CCP1M2                       EQU     H'0002'
CCP1M1                       EQU     H'0001'
CCP1M0                       EQU     H'0000'

;----- RCSTA Bits ---------------------------------------------------------
SPEN                         EQU     H'0007'
RX9                          EQU     H'0006'
SREN                         EQU     H'0005'
CREN                         EQU     H'0004'
ADEN                         EQU     H'0003'
FERR                         EQU     H'0002'
OERR                         EQU     H'0001'
RX9D                         EQU     H'0000'

;----- CMCON Bits ---------------------------------------------------------

C2OUT                        EQU     H'0007'
C1OUT                        EQU     H'0006'
C2INV                        EQU     H'0005'
C1INV                        EQU     H'0004'
CIS                          EQU     H'0003'
CM2                          EQU     H'0002'
CM1                          EQU     H'0001'
CM0                          EQU     H'0000'

;----- OPTION Bits --------------------------------------------------------

NOT_RBPU                     EQU     H'0007'
INTEDG                       EQU     H'0006'
T0CS                         EQU     H'0005'
T0SE                         EQU     H'0004'
PSA                          EQU     H'0003'
PS2                          EQU     H'0002'
PS1                          EQU     H'0001'
PS0                          EQU     H'0000'

;----- PIE1 Bits ----------------------------------------------------------

EEIE                         EQU     H'0007'
CMIE                         EQU     H'0006'
RCIE                         EQU     H'0005'
TXIE                         EQU     H'0004'
CCP1IE                       EQU     H'0002'
TMR2IE                       EQU     H'0001'
TMR1IE                       EQU     H'0000'

;----- PCON Bits ----------------------------------------------------------

OSCF                         EQU     H'0003'
NOT_POR                      EQU     H'0001'
NOT_BO                       EQU     H'0000'
NOT_BOR                      EQU     H'0000'
NOT_BOD                      EQU     H'0000'

;----- TXSTA Bits ----------------------------------------------------------
CSRC                         EQU     H'0007'
TX9                          EQU     H'0006'
TXEN                         EQU     H'0005'
SYNC                         EQU     H'0004'
BRGH                         EQU     H'0002'
TRMT                         EQU     H'0001'
TX9D                         EQU     H'0000'

;----- EECON1 Bits ---------------------------------------------------------
WRERR                        EQU     H'0003'
WREN                         EQU     H'0002'
WR                           EQU     H'0001'
RD                           EQU     H'0000'

;----- VRCON Bits ---------------------------------------------------------

VREN                         EQU     H'0007'
VROE                         EQU     H'0006'
VRR                          EQU     H'0005'
VR3                          EQU     H'0003'
VR2                          EQU     H'0002'
VR1                          EQU     H'0001'
VR0                          EQU     H'0000'

;==========================================================================
;
;       RAM Definition
;
;==========================================================================

    __MAXRAM H'01FF'
    __BADRAM H'07'-H'09', H'0D', H'13'-H'14', H'1B'-H'1E'
    __BADRAM H'87'-H'89', H'8D', H'8F'-H'91', H'93'-H'97', H'9E'
    __BADRAM H'105', H'107'-H'109', H'10C'-H'11F', H'150'-H'16F'
    __BADRAM H'185', H'187'-H'189', H'18C'-H'1EF'


;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

_BODEN_ON                    EQU     H'3FFF' ;Backwards compatability to 16F62X
_BODEN_OFF                   EQU     H'3FBF' ;Backwards compatability to 16F62X
_BOREN_ON                    EQU     H'3FFF'
_BOREN_OFF                   EQU     H'3FBF'
_CP_ON                       EQU     H'1FFF'
_CP_OFF                      EQU     H'3FFF'
_DATA_CP_ON                  EQU     H'3EFF'
_DATA_CP_OFF                 EQU     H'3FFF'
_PWRTE_OFF                   EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LVP_ON                      EQU     H'3FFF'
_LVP_OFF                     EQU     H'3F7F'
_MCLRE_ON                    EQU     H'3FFF'
_MCLRE_OFF                   EQU     H'3FDF'
_RC_OSC_CLKOUT               EQU     H'3FFF'
_RC_OSC_NOCLKOUT             EQU     H'3FFE'
_ER_OSC_CLKOUT               EQU     H'3FFF' ;Backwards compatability to 16F62X
_ER_OSC_NOCLKOUT             EQU     H'3FFE' ;Backwards compatability to 16F62X
_INTOSC_OSC_CLKOUT   	     EQU     H'3FFD'
_INTOSC_OSC_NOCLKOUT         EQU     H'3FFC'    
_INTRC_OSC_CLKOUT   	     EQU     H'3FFD' ;Backwards compatability to 16F62X
_INTRC_OSC_NOCLKOUT	     EQU     H'3FFC' ;Backwards compatability to 16F62X
_EXTCLK_OSC                  EQU     H'3FEF'
_HS_OSC                      EQU     H'3FEE'
_XT_OSC                      EQU     H'3FED'
_LP_OSC                      EQU     H'3FEC'



;============================================================================================================



     __CONFIG (_BOREN_OFF&_CP_OFF&_DATA_CP_OFF&_PWRTE_ON&_WDT_OFF&_LVP_OFF&_MCLRE_OFF&_XT_OSC)     



;====================================================================================
;          
; =================================================================================== 


    CBLOCK		70h
		LED_OUT :8    ; 8    
		fsr_temp 
		status_temp
		w_temp
		pause_        ;  - *2 
        pause_H       ;
		tmr2_count   ; 3-  TMR2
		fflags_ ; 7-bit   1 ., 6 - , 5 - -   
				;4 - , 3-   ., 2 -  --> F=1/T,  -  
                ;1 - T (t), 0 -   
 
    ENDC                  ;7Eh

    CBLOCK      20h
		out_bcd :4
		regime_      ;0-. , 1-., 3-, 4-. .
                     ;5-. . 
		reg_temp
		butt_flags   ;  . 
		PC_temp
		tmr1_count   ; 3-  TMR1
		count_
		column        ;  
		var_temp
		freq_  :4   ;   .  (f, T, t)  2- 
        temp :4
        var_pause 
        flags_      ;  : (7 -    0.25 , 
    ENDC    ;35h
;------------------------------------------------------------------------------------




;====================================================================================
;                            
;====================================================================================
    CONSTANT PUSH_BUTT_WAIT=.80  ;.     (t*10)(80-8s)


IND_INTERVAL SET 7h         ; 6  7 !! (.    0,25  0,5 )

      IF  (IND_INTERVAL != 6h)&&(IND_INTERVAL != 7h)
IND_INTERVAL SET 7h          ;<6  >7 -->7
      ENDIF


LEVEL_CONT SET .10   ; 1/3 -   . .  ( 5  .30)

      IF  (LEVEL_CONT < .5)||(LEVEL_CONT >.30)
LEVEL_CONT SET .15           ;<5  >30 -->15
      ENDIF



;------------------------------------------------------------------------------------
;    
;------------------------------------------------------------------------------------
 
_A       EQU  b'01110111' ;   A - 10
_b       EQU  b'01111100' ;   b - 11
_C       EQU  b'00111001' ;   C - 12
_d       EQU  b'01011110' ;   d - 13
_E       EQU  b'01111001' ;   E - 14   
_F       EQU  b'01110001' ;   F - 15
_SPACE   EQU  b'00000000' ;   - 16
_P       EQU  b'01110011' ;   P - 17
_t       EQU  b'01111000' ;   t - 18                           
_L       EQU  b'00111000' ;   L - 19
_r       EQU  b'01010000' ;   r - 20
_BOTTOM  EQU  b'00001000' ;  '_' - 21
_u       EQU  b'00011100' ;  'u' - 22
_Y       EQU  b'01101110' ;   Y - 23
_U       EQU  b'00111110' ;   U - 24
_H       EQU  b'01110110' ;   H - 25
_MIDDLE  EQU  b'01000000' ;  '-'- 26
_UP      EQU  b'00000001' ;  '. '- 27
_q       EQU  b'01100111' ;   q - 28                    
_N       EQU  b'00110111' ;    - 29
_G       EQU  b'00111101' ;   G - 30
_I       EQU  b'00000110' ;  'I'
_O       EQU  b'00111111' ;  'O'  
_S       EQU  b'01101101' ;  'S'






;------------------------------------------------------------------------------------
            org 0
            goto      begin



;==================================================================================
;==================================================================================
;      
;==================================================================================
;==================================================================================			          

			org 4

			movwf       w_temp
            swapf       STATUS,w
            movwf       status_temp  ;coxpa W  STATUS
			swapf       FSR,w
			movwf       fsr_temp

			clrw        
            movwf       STATUS ; 0,  0
		
			btfsc       PIR1,TMR2IF
            goto        tmr2_int
 
        	btfsc       PIR1,TMR1IF
            goto        tmr1_int 

			goto        exit_

;=============================  TMR1============================================ 
tmr1_int 
			bcf         PIR1,TMR1IF 
            bcf         tmr1_count,7 ;    TMR1  . 			
			incf        tmr1_count,f ; .    TMR1
			btfss       PIR1,CCP1IF ;   ?
            goto        ti_0  ;
            movf        CCPR1H,f  ;  = 0 -->    - TMR1
            btfsc       STATUS,Z  ;
            goto        ti_0 
            bsf         tmr1_count,7 ;  7 -   TMR1  
            goto        exit_
ti_0
			movlw       .46            ;
			subwf       tmr1_count,w    ; >=46?
			btfss       STATUS,C        ;
			goto        exit_           ;  .    3.014 .
			bsf         fflags_,1      ;   
			bsf         PIR1,CCP1IF      ;    . . 
			goto        exit_

;============================   TMR2 ======================================
tmr2_int ;........................ ............................................
			btfss       fflags_,3
			goto        t2i_1     ;    
			btfsc       fflags_,7
			goto        t2i_3      ;    
			bsf         fflags_,7  ; c 
			clrf        TMR0          ;
			clrf        tmr2_count
			bsf         STATUS,RP0  ; bank 1
			bsf         TRISB,3 ;    (TRISB3=0,   4-7  )
			bcf         STATUS,RP0  ; bank 0
			goto        t2i_1
t2i_3
			btfss       fflags_,5  ; ? 
			goto        t2i_4      ; 
			bsf         STATUS,RP0  ; bank 1
			bcf         TRISB,3 ;    
			bcf         STATUS,RP0  ; bank 0
			bsf         fflags_,4  ; c 
			goto        t2i_1
t2i_4
			incf        tmr2_count,f
			btfss       STATUS,Z
			goto        t2i_1
			btfsc       fflags_,6  ;   .?
			goto        t2i_2
			bsf         fflags_,6  ;  .
			movlw       .13
			movwf       tmr2_count ; .. = 256-(500-256-1)=13 (1-2)
			goto        t2i_1
t2i_2
			bsf         fflags_,5  ; .  -  
	   ;------------------------------------------------------------------------------------								
t2i_1    

		 	incf        pause_,f   ;  "pause_"  2 
            btfsc       STATUS,Z
            incf        pause_H,f

       ;.......................... ....................................  

 			incf        column,f  ; . 
			btfsc       column,3  ;   7- 
			clrf        column    ;  0-  

			clrf        PORTB    ;  
			clrf        PORTA    ;  

			movlw       LED_OUT
			addwf       column,w 
			movwf       FSR      ;  . 

			movf        column,w ;
			btfsc       INDF,3      ;
			iorlw       b'00001000' ;  3-  LED_OUT -  
            movwf       PORTA    ;    3- 

			movf        INDF,w  ; . 
			andlw       b'11110111' ;  3- 

			movwf       PORTB      ;    LED_OUT . 

            bcf         PIR1,TMR2IF  ;    

;=========================     ==============================
exit_  		swapf       fsr_temp,w
			movwf       FSR       ; . FSR
		    swapf       status_temp,w
            movwf       STATUS
            swapf       w_temp,f  ;  W  STATUS
            swapf       w_temp,w
 			retfie

;-----------------------------------------------------------------------------------
;===================================================================================




			

;====================================================================================
;                         A
;====================================================================================
;                  ()
;====================================================================================
begin       bcf       STATUS,RP1
			bsf       STATUS,RP0  ; bank 1
			movlw     b'00001000'
			movwf     TRISB
			movlw     b'11110000' ;      
			movwf     TRISA      
			clrwdt
          	movlw     b'11100111'
            movwf     OPTION_REG  ; TMR0  RA4,  , .TMR0- 256, .-.

            clrf      LED_OUT
            clrf      LED_OUT+1
            clrf      LED_OUT+2
            clrf      LED_OUT+3
            clrf      LED_OUT+4
            clrf      LED_OUT+5
            clrf      LED_OUT+6
            clrf      LED_OUT+7  ;   

            movlw     b'00000010'
			movwf     PIE1     ;   TMR2  
 		
			movlw     .124
            movwf     PR2   ;    TMR2 - 125*16 = 2 

			bcf       STATUS,RP0 ; bank0
            movlw     07h
			movwf     CMCON  ; . 
            movlw     b'00000111'
			movwf     T2CON     ;  TMR2, . = 16. .  - 0.

			clrf      fflags_
			clrf      tmr2_count
		    clrf      TMR0		
			clrf      TMR2
            movlw     b'00000001' 
			movwf     regime_    ; . 
            movwf     column     ;  "1"
			movlw     b'11000000' ;  .   ,
			movwf     INTCON    ;  + 


;================================================================================            
;		       	          ( )
;================================================================================
            movlw     .10
			call      out_word__ ;   . 'FRt-test'
            movlw     .255
            call      pause__
            movlw     .255
            call      pause__
            movlw     .255
            call      pause__  ; 1.5 sec
            movlw     .6
			call      out_word__ ;   . '-HELLO- '
            movlw     .255
            call      pause__
            movlw     .255
            call      pause__  ; 1 sec



start 

			btfsc     regime_,0 ; 0  -  
			call      freq_standart__
			btfsc     regime_,1 ; 1  - . 
			call      freq_special__
            btfsc     regime_,2 ; 2  - 
            call      period__
            btfsc     regime_,3 ; 3  -  1
            call      t_meter__
            btfsc     regime_,4 ; 4  -  0
            call      t_meter__

			movlw     .100      
		    call       delay_Wx6__    ; 0.6 ms      ?????????????????????????????

			call      button__



			btfsc     butt_flags,0 
			call      regime__    ;   1- 
		

 			 goto   start



			


;=======================================================================================
;    
; 1.  1000  -  . F=1/T,   - 
; 2.  1000  -   .  1 .
;     - 100  (..  0 - 1000   900 - 50000000)
;=======================================================================================
freq_special__
            btfsc      fflags_,2  ;   . ?
            goto       fs_0

            call       freq_standart__   ; . -

            movf       fflags_,w
            andlw      b'11111000'
            btfss      STATUS,Z  ;     
            return            

            movf       out_bcd+3,w
            iorwf      out_bcd+2,w
            btfss      STATUS,Z   ; >9999 ?
            return
            movf       out_bcd+1,w
            sublw      08h
            btfss      STATUS,C   ; >899 ?
            return
            bsf        fflags_,2  ;   .  (. <900)

fs_0               ; .............   F = 1/T .................................

            btfss      pause_,7 ; ............. 1   0.5 .........
            goto       fs_4     
            btfsc      flags_,7
            return        ;   6  pause_ =1  =1
            goto       fs_5
fs_4            
            bcf        flags_,7 ;   .
            return              ;................................................
fs_5  
            bsf        flags_,7 ; .  .
            call       T_imp__    ;  
            clrf       freq_+3
            btfsc      fflags_,0  ; the "too small" flag  
            goto       fs_1   ; .  . 

            btfss      fflags_,1  ; ?
            goto       fs_2
            clrf       out_bcd
            clrf       out_bcd+1
            clrf       out_bcd+2
            goto       fs_6
fs_2   
            call       DIVIDE_1byX__  ; F=1/T
            andlw      0ffh
            btfsc      STATUS,Z  ; w=0(  0) --> .  . 
            goto       fs_1  

                                               ; 
            call       b2bcd__  ; bin---->bcd
                                    ; F > 999.999 ---> . -
            movf       out_bcd+3,f
            btfss      STATUS,Z   ;>999.999 
            goto       fs_1   ; .  . 
fs_6
            movlw      3    ;   . 3 (  0) 
            call       outBCD__
            movlw      _F
            movwf      LED_OUT+7  ; "F"
            movlw      _UP
            movwf      LED_OUT+6  ; " "
            return
fs_1
            bcf        fflags_,2  ;    
            return


;-----------------------------------------------------------------------------



;=======================================================================================
;    
; 1.  1000  -   
; 2.  1000  -   .  1 .  . T=1/F,  F - 
;     - 100  (..  0 - 1100   1000 - 50000000)
;=======================================================================================
period__
            btfss      fflags_,2  ;      (=0)?
            goto       pe_20

            call       freq__   ;  -

            movf       fflags_,w
            andlw      b'11111000'
            btfss      STATUS,Z  ;     
            return            

            clrf       var_temp;... . freq_  3-.  var_temp - ...
pe_12                          ; ..  - 3-. 
            movf       freq_+3,f 
            btfsc      STATUS,Z  ; .   - . . .=0
            goto       pe_11
            bcf        STATUS,C
            rrf        freq_+3,f
            rrf        freq_+2,f
            rrf        freq_+1,f
            rrf        freq_,f
            incf       var_temp,f
            goto       pe_12    ;....................................................
pe_11
            call       DIVIDE_1byX__  ; F=1/T
            andlw      0ffh
            btfsc      STATUS,Z  ; w=0 --> .    
            goto       pe_10  
            
                    ;......  . freq_  .  var_temp ...........
            movf       var_temp,f 
pe_13
            btfsc      STATUS,Z
            goto       pe_14
            bcf        STATUS,C
            rrf        freq_+3,f
            rrf        freq_+2,f
            rrf        freq_+1,f
            rrf        freq_,f
            decf       var_temp,f
            goto       pe_13  ;....................................................
pe_14
                ;:  freq_ >= 1000000 (000F4240h) -->  . 

            movlw      40h          
            subwf      freq_,w      
 
            movlw      42h          
            btfss      STATUS,C     
            addlw      1            
            subwf      freq_+1,w        

            movlw      0fh       
            btfss      STATUS,C  
            addlw      1         
            subwf      freq_+2,w   

            clrw                   
            btfss      STATUS,C    
            addlw      1           
            subwf      freq_+3,w   

            btfsc      STATUS,C  ; freq_ >= 1000000 (000F4240h)?
            goto       pe_10     ;.....................................................       

                                              ;  .............................
            call       b2bcd__  ; bin---->bcd

            movlw      3    ;   . 3 (  0) 
            call       outBCD__

            movlw      _P
            movwf      LED_OUT+7  ; "P"
            movlw      _UP
            movwf      LED_OUT+6  ; " "
            return     
pe_10       bcf        fflags_,2  ;     
            return     ;.......................  P=1/F.......................


pe_20                 ; .............   T ............................

                      ; ............. 1   0.25/0.5 .........

            call      time_meter__ ; ( . W=0 - . . W=1 - )
            andlw     1
            btfsc     STATUS,Z
            return    ; W=0

            call       T_imp__    ;  
            clrf       freq_+3
            btfsc      fflags_,0  ; the "too small" flag  
            goto       pe_21       ; .   T=1/F

            movf       temp,f  ;  . TMR0 =0? 
            btfsc      STATUS,Z
            goto       pe_18         ;  ---> " NO_SIG."............    

            btfsc      fflags_,1  ; ?
            goto       pe_22      ; c    ---------------

                                               ; 
            call       b2bcd__  ; bin---->bcd
                                    ; F > 999.999 ---> . -
            movf       out_bcd+3,w
            iorwf      out_bcd+2,w
            btfss      STATUS,Z   ;>9999? 
            goto       pe_17     ; 
            movlw      09h
            subwf      out_bcd+1,w 
            btfss      STATUS,C   ; <900?
            goto       pe_21
pe_17            
            clrw      ;  
            call       outBCD__
            goto       pe_19
pe_18
            movlw      7
            call       out_word__ ;  "  NO_SIG."
            bsf        LED_OUT,3
pe_19
            movlw      _P
            iorlw      b'10000000' ; 
            movwf      LED_OUT+7  ; "P."
            return

pe_22               ; c    -----------------------------------------------
            movlw      .9
			call       out_word__ ;   . "F_tOO_HI"
            movlw      _P
            movwf      LED_OUT+7  ;    F  P
            return

pe_21
            bsf        fflags_,2  ;    T=1/F
            return


;-----------------------------------------------------------------------------




;====================================================================================
;     (IND_INTERVAL =6->0.25s, =7->0.5s)
;====================================================================================
time_meter__
            btfss      pause_,IND_INTERVAL ; ....... 1   0.25/0.5 .........
            goto       tm_111     
            btfsc      flags_,7
            retlw      0        ;   6  pause_ =1  =1
            goto       tm_112
tm_111            
            bcf        flags_,7 ;   .
            retlw      0         ;   6  pause_ =0
tm_112  
            bsf        flags_,7 ; .  .
            retlw      1        ; .....................................

;------------------------------------------------------------------------------------




;===================================================================================
;   
;===================================================================================
freq_standart__
            call       freq__
            movf       fflags_,w
            andlw      b'11111000'
            btfss      STATUS,Z  ;     
            return            

			call       b2bcd__      ; .  -. 
			clrw                 ; W=0 -->   
         	call       outBCD__     ;      . 

            movf       LED_OUT+7,f
            btfss      STATUS,Z
            return               ;     

            movlw      _F
            iorlw      b'10000000' ; 
            movwf      LED_OUT+7  ; "F."

            return
;-----------------------------------------------------------------------------------







;===================================================================================
;       
;  : fflags_,  () - freq_ (4-.)
;===================================================================================
freq__
			btfsc      fflags_,3
			goto       fr_1      ;  - . 

			clrf       freq_+2   ;.........   ....................
			clrf       freq_+3
			bsf        STATUS,RP0 ;bank1 
			clrwdt
          	movlw      b'11100111'
            movwf      OPTION_REG  ; TMR0  RA4,  , .TMR0- 256, .-.
			bcf        TRISB,3   ;  . 
			bcf        STATUS,RP0 ;bank0 
            bcf        INTCON,T0IF   ;   TMR0 
			bsf        fflags_,3    ;.................................................
			return
fr_1
			btfss      INTCON,T0IF ;
			goto       fr_3        ;
			bcf        INTCON,T0IF ;
			incf       freq_+2,f   ;
			btfsc      STATUS,Z    ;   TMR0,  . 
			incf       freq_+3,f   ; 	
fr_3
			btfss      fflags_,4
			return                 ; .   - 
			
			movf       TMR0,w ; TMR0  W --> freq_+1
			movwf      freq_+1
    		
                        ;  -  (.   ).......................
			clrf       count_
			btfss      TMR0,0
			goto       fr_4  ;  0  =0
fr_2
			bsf        PORTB,3     ;  . 
			incf       count_,f
			bcf        PORTB,3
			btfsc      TMR0,0 ; 0  TMR0 (1-->0)?
			goto       fr_2
			goto       fr_5
fr_4
			bsf        PORTB,3     ;  . 
			incf       count_,f
			bcf        PORTB,3
			btfss      TMR0,0 ; 0  TMR0 (0-->1)?
			goto       fr_4
fr_5              ; ....  - <=1540.....................

			comf       count_,f  ;
			incf       count_,w ;   count_ -->W:  W -   
 			movwf      freq_

			movlw      b'00000111'
			andwf      fflags_,f    ; c    -
            
			return

;------------------------------------------------------------------------------------------






;=======================================================================================
;     (.  .)
;
;=======================================================================================

t_meter__
            call      time_meter__ ; ( . W=0 - . . W=1 - )
            andlw     1
            btfsc     STATUS,Z
            return    ; W=0

                     ;  ------------------------------------------
            movlw     8
            movwf     temp+1
            movf      pause_,w    ; . 
            movwf     temp+2      ;
            incf      pause_H,w   ;
            movwf     temp+3      ; . pause_H+1  .  0.5 

tm_2   ;   (   0.5 ) . . t .....................
            call      t_imp__             

            btfsc     INTCON,T0IF  ;   TMR0 
            goto      tm_0         ;  ---> "  "....

            movf       temp,f  ;  . TMR0 =0? 
            btfsc      STATUS,Z
            goto       tm_9         ;  ---> " NO_SIG."............    

            btfsc     fflags_,1  ; ?
            goto      tm_10         ;  ---> "  "....   

            movf      temp,w  ;  . TMR0  
            sublw     .15   
            btfss     STATUS,C ; >15?
            goto      tm_0         ;  ---> "   "....

            btfss     fflags_,0    ; the "too small" flag c  
            goto      tm_1         ; .    ....
   
            movf      pause_,w  ;  0.5  ?
            subwf     temp+2,w  ;
            movf      pause_H,w ;
            btfss     STATUS,C  ;
            incfsz    pause_H,w ; 
            subwf     temp+3,w  ; (pause_(1)+0.5c)-pause_(2)<0 ?           
            btfss     STATUS,C  ; 0.5 s  ?
            goto      tm_3    ; - exit

            decfsz    temp+1,f   ;  8 max.
            goto      tm_2  ;...............................................................


tm_3               ; .  --------------------------------------
            movf      freq_,w   ;
            movwf     out_bcd   ;
            movf      freq_+1,w ;
            movwf     out_bcd+1 ;
            movf      freq_+2,w ;
            movwf     out_bcd+2 ;   freq_  out_bcd

            call      T_imp__      ;. 

            btfss     fflags_,0    ;  the "too small" flag 
            goto      tm_4

            call      t_256__   ; . . <256

            btfsc      fflags_,1   ; ? ()
            return                ; 
            btfsc     CCPR1H,0    ; t>=128 uS (.  . >=256 uS)()
            return               ;
   
            btfss     fflags_,0    ; the "too small" flag =0
            goto      tm_1         ; .    ....


            movf      freq_,w   ;
            movwf     out_bcd   ; .  out_bcd
            clrf      out_bcd+1
            clrf      out_bcd+2

            call      T_256__      ; .  .  T<256...............

            btfsc     CCPR1H,0    ; t>=128 uS (.  . >=256 uS)()
            return               ; 

            btfsc     fflags_,0    ; the "too small" flag 
            goto      tm_0         ; . "  ".....

tm_4
            btfsc      fflags_,1   ; ?
            goto       tm_10       ;  ---> "  "....    


        ;  .  -----------------------------------------------

               ; (t_imp_1/0 -> .) minus 
            movf      freq_,w
            subwf     out_bcd,f
            movf      freq_+1,w
            btfss     STATUS,C
            incfsz    freq_+1,w
            subwf     out_bcd+1,f
            movf      freq_+2,w
            btfss     STATUS,C
            incfsz    freq_+2,w
            subwf     out_bcd+2,f

            btfsc     STATUS,C       ;     (t_imp_1/0 -> .) ?
            goto      tm_12          ; x>=0

            movf      out_bcd+1,w ;....  .  ffh?..............
            andwf     out_bcd+2,w ;
            xorlw     0ffh ; comf ;
            btfss     STATUS,Z    ; 
            return                ; ........ --> o -  .............
            
            movlw     1h        ;
            addwf     out_bcd,w ;
            btfss     STATUS,C  ;
            goto      tm_6      ;  <= 1 -  
            goto      tm_5             

tm_12
            movf      out_bcd+1,w ;....  .  0?..............
            iorwf     out_bcd+2,w ;
            btfss     STATUS,Z    ; 
            return                ; ........ --> o -  ...........

            movf      out_bcd,w    ;
            sublw     1h           ;   <= 1 -  
            btfsc     STATUS,C     ; 
            goto      tm_6         ;...........................................
    

                    ; (t_imp_1/0 -> .) - .+

            movf      out_bcd,w
            movwf     freq_
            clrf      freq_+1
            clrf      freq_+2
            goto      tm_14         ; .    ...............            

tm_5              ;  (t_imp_1/0 -> .)-  .....................
                  ;  t = (t-T)+T
            movf      out_bcd,w
            addwf     freq_,f
            movf      out_bcd+1,w
            btfsc     STATUS,C
            incfsz    out_bcd+1,w
            addwf     freq_+1,f
            movf      out_bcd+2,w
            btfsc     STATUS,C
            incfsz    out_bcd+2,w
            addwf     freq_+2,f    ;  freq_  
            goto      tm_14         ; .    ...            

tm_6          ; (T+t)   T (t_0  t_1  ).....................

            call      t_1_or_0__   ;  
            movwf     temp         ; . W
            btfsc     temp,1    ; =2
            return              ; () - 
            
            btfsc     regime_,4
            goto      tm_7
                    ; . . 
            btfsc     temp,0    ; .  (t=T)   
            goto      tm_14         ; .    ...            
            goto      tm_8    ; =0

tm_7                ; . . 
            btfss     temp,0    ; .  (t=T)   
            goto      tm_14         ; .    ...            
                        
tm_8              ;t=0 ( )
            clrf      freq_
            incf      freq_,f  ; =1us
            clrf      freq_+1
            clrf      freq_+2
            clrf      freq_+3
                     ; .    ...
  
              ;------------------------- ---------------------------------
          
tm_14
            bsf        flags_,6 ; .  - 
            goto       tm_13
tm_1
            bcf        flags_,6  ;. .  - 
tm_13
			call       b2bcd__      ; .  -. 
			clrw                 ; W=0 -->   
         	call       outBCD__     ;      . 

            btfsc      flags_,6  ;  - 
            bsf        LED_OUT,7 ;   . .

            movlw      _t
     ;       iorlw      b'10000000' ; 
            movwf      LED_OUT+7  ; "t"

            movlw      _UP
            btfsc      regime_,4
            movlw      _BOTTOM      ; ". " - .3, "_" - .4

            movf       LED_OUT+6,f
            btfsc      STATUS,Z
            movwf      LED_OUT+6    ; 2-     
            btfss      STATUS,Z
            movwf      LED_OUT+7    ; 1-     
  
            return

tm_0               ; c  -------------------------------
            movlw      .9
			call       out_word__ ;   . "tOO_HI_F"
            bcf        flags_,6  ;. .  - 
            return

tm_9               ;  .........................
            movlw      .7
			call       out_word__ ;   . "NO SIG."
            bsf        LED_OUT,3  ; . . .
            bcf        flags_,6  ;. .  - 
            return

tm_10               ; c    -----------------------------------------------
            movlw      .9
			call       out_word__ ;   . "F_tOO_HI"
            movlw      _P
            movwf      LED_OUT+7  ;    F  P
            bcf        flags_,6  ;. .  - 
            return

            
            
;------------------------------------------------------------------------------------------

;=======================================================================================
;        (LEVEL_CONT*3 )
;=======================================================================================

t_1_or_0__
            movlw      .3*LEVEL_CONT     
            movwf      temp+1
            clrf       temp
tor_1
            btfsc      PORTB,3
            incf       temp,f    ; +1  . 
            decfsz     temp+1,f
            goto       tor_1   ;  30 

            movf       temp,w
            sublw      LEVEL_CONT
            btfsc      STATUS,C
            retlw      0         ;  0

            movf       temp,w
            sublw      .2*LEVEL_CONT
            btfss      STATUS,C
            retlw      1         ;  1

            retlw      2         ; 

;-----------------------------------------------------------------------------------

            
                       





;000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000



;=========================================================================================
;       (freq_ -    )
;=========================================================================================

T_imp__
            call       t_imp_begin__ ;  

			movlw      b'00000100'
			clrf       TMR0
			bcf        PIR1,CCP1IF  ;  
			movwf      CCP1CON ; .  .  (00000100)
T_1
			btfss      PIR1,CCP1IF ; ?........................
			goto       T_1  
			movf       CCPR1L,w    ;
			movwf      freq_       ;
			movf       CCPR1H,w    ;
			movwf      freq_+1     ;
			movf       tmr1_count,w; . 1- 
			movwf      freq_+2     ;
            bcf        tmr1_count,7 ;    TMR1  . 			
			bcf        PIR1,CCP1IF  ;  
T_3
			btfss      PIR1,CCP1IF ; 2- ?........................
			goto       T_3 
			movf       TMR0,w   ;  (TMR0-1) - . . 
			clrf       CCP1CON    ;.  

			call       t_imp_end__
			return


;---------------------------------------------------------------------------------------





;=========================================================================================
;         
;   (freq_ -    ) 
;=========================================================================================

t_imp__
            call       t_imp_begin__ ;  

            btfsc      regime_,4
            goto       ti_5

			movlw      b'00000101'
			clrf       TMR0
			bcf        PIR1,CCP1IF  ;  
			movwf      CCP1CON ; .   
ti_7
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti_7  
			movf       CCPR1L,w    ;
			movwf      freq_       ;
			movf       CCPR1H,w    ;
			movwf      freq_+1     ;
			movf       tmr1_count,w; . 1- 
			movwf      freq_+2     ;			
            bcf        tmr1_count,7 ;    TMR1  . 			
			decf       CCP1CON,f   ;.   
			bcf        PIR1,CCP1IF  ;  
ti_6
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti_6 
			incf       TMR0,w   ;  - . . 
			clrf       CCP1CON    ;.  

			call       t_imp_end__
			return


ti_5  ; . . ......................................................
			movlw      b'00000100'
			clrf       TMR0
			bcf        PIR1,CCP1IF  ;  
			movwf      CCP1CON ; .   
ti_1
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti_1  
			movf       CCPR1L,w    ;
			movwf      freq_       ;
			movf       CCPR1H,w    ;
			movwf      freq_+1     ;
			movf       tmr1_count,w; . 1- 
			movwf      freq_+2     ;			
            bcf        tmr1_count,7 ;    TMR1  . 			
			incf       CCP1CON,f   ;.   
			bcf        PIR1,CCP1IF  ;  
ti_3
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti_3 
			incf       TMR0,w   ;  - . . 
			clrf       CCP1CON    ;.  

			call       t_imp_end__   
			return


;---------------------------------------------------------------------------------------









;=======================================================================================
;  -   T_imp__  t_imp__
;========================================================================================
            
t_imp_begin__
            movlw      b'00000100'
            andwf      fflags_,f    ;  ,  ""-"."
			clrf       T1CON ;  TMR1
			clrf       TMR1L
			clrf       TMR1H
            bcf        PIR1,TMR1IF
			clrf       tmr1_count
			clrwdt
          	movlw      b'11111000' ; TMR0  RA4, . , .-.  .off	
     ;. .
            btfsc      regime_,3
            movlw      b'11101000'  ; TMR0  RA4, . , .-.  . off	
			bsf        STATUS,RP0 ;bank1 
            movwf      OPTION_REG  		
			bsf        TRISB,3     ; RB3 - 
			bsf        PIE1,TMR1IE  ;. .  TMR1

			bcf        STATUS,RP0 ;bank0 
			bcf        INTCON,GIE   ;..................................................
ti_2
			btfss      PIR1,TMR2IF
			goto       ti_2
			bsf        INTCON,GIE   ;..    TMR2.............

            clrf       TMR0
            bcf        INTCON,T0IF ;   . TMR0
			movlw      b'00000001'
			movwf      T1CON   ; .-1/1, .-osc/4,  TMR1
            return


;--------------------------------------------------------------------------------------------







;=========================================================================================
;  -    T_imp__, t_imp1__  t_imp0__
;=========================================================================================

t_imp_end__
            movwf      temp  ;       TMR0

            btfsc      INTCON,T0IF  ;   TMR0
            bsf        fflags_,0 ;  " "
            
            sublw      2h      ; TMR0 >2 --> error (  )
            btfss      STATUS,C
            bsf        fflags_,0 ;  " "

			clrf       T1CON ;  TMR1 
			bcf        PIR1,CCP1IF  ;  
            btfsc      tmr1_count,7  ;............................................ 
            decf       tmr1_count,f
            btfsc      freq_+2,7
            decf       freq_+2,f
            movlw      b'01111111'
            andwf      tmr1_count,f
            andwf      freq_+2,f ; .....    . TMR1   

			movf       freq_+2,w    ;............................................
			subwf      tmr1_count,w
			movwf      freq_+2
			movf       freq_+1,w
			subwf      CCPR1H,w
			movwf      freq_+1
			btfss      STATUS,C
			decf       freq_+2,1
			movf       freq_,w
			subwf      CCPR1L,w
			movwf      freq_
			btfsc      STATUS,C
			goto       t0_4
			decf       freq_+1,f
			incf       freq_+1,f
			btfsc      STATUS,Z
			decf       freq_+2,f
			decf       freq_+1,f      ;......  --> freq_.............
t0_4
            clrf       freq_+3   ;    =0
			bsf        STATUS,RP0 ;bank1 
			bcf        PIE1,TMR1IE  ; .  TMR1
			bcf        STATUS,RP0 ;bank0 
			return
;---------------------------------------------------------------------------------------	





;=========================================================================================
;       ( < 256/2 uS)
;  (freq_ -    )
;=========================================================================================

T_256__
            call       t_256_begin__ ;  

			movlw      b'00000100'
			clrf       TMR0
			bcf        PIR1,CCP1IF  ;  
			movwf      CCP1CON ; .  .  (00000100)
T2_1
			btfss      PIR1,CCP1IF ; ?........................
			goto       T2_1  
			movf       CCPR1L,w    ;
			movwf      freq_       ;
			bcf        PIR1,CCP1IF  ;  
T2_3
			btfss      PIR1,CCP1IF ; 2- ?........................
			goto       T2_3 
			movf       TMR0,w   ;  (TMR0-1) - . . 
			clrf       CCP1CON    ;.  

            call       t_256_end__
            movf       freq_,w
            sublw      7h
            btfsc      STATUS,C
            bsf        fflags_,0  ; .  "  "  T<8

			return


;---------------------------------------------------------------------------------------






;=========================================================================================
;    .  .    <256/2 
; (freq_ -    )
;=========================================================================================

t_256__
            call       t_256_begin__ ;  
            
            btfsc      regime_,4
            goto       ti2_5

                    ; .  ...........................................
			movlw      b'00000101'
			clrf       TMR0
			bcf        PIR1,CCP1IF  ;  
			movwf      CCP1CON ; .   
ti2_7
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti2_7  
			movf       CCPR1L,w    ;
			movwf      freq_       ;
			decf       CCP1CON,f   ;.   
			bcf        PIR1,CCP1IF  ;  
ti2_6
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti2_6 
			incf       TMR0,w   ;  - . . 
			clrf       CCP1CON    ;.  

			call       t_256_end__
			return


ti2_5  ; . . ......................................................
			movlw      b'00000100'
			clrf       TMR0
			bcf        PIR1,CCP1IF  ;  
			movwf      CCP1CON ; .   
ti2_1
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti2_1  
			movf       CCPR1L,w    ;
			movwf      freq_       ;
			incf       CCP1CON,f   ;.   
			bcf        PIR1,CCP1IF  ;  
ti2_3
			btfss      PIR1,CCP1IF ; ?........................
			goto       ti2_3 
			incf       TMR0,w   ;  - . . 
			clrf       CCP1CON    ;.  

			call       t_256_end__   
			return

;-------------------------------------------------------------------------------------------





;=======================================================================================
;  -   _256_
;========================================================================================
            
t_256_begin__
            movlw      b'00000100'
            andwf      fflags_,f    ;  ,  ""-"."
			clrf       T1CON ;  TMR1
			clrf       TMR1L
			clrf       TMR1H
            bcf        PIR1,TMR1IF
			bsf        STATUS,RP0 ;bank1 
			bsf        TRISB,3     ; RB3 - 
			clrwdt
          	movlw      b'11111000' ; TMR0  RA4, . , .-.  .off	
     ;. .
            btfsc      regime_,3
            movlw      b'11101000'  ; TMR0  RA4, . , .-.  . off	
            movwf      OPTION_REG  		
			bcf        STATUS,RP0 ;bank0 

			bcf        INTCON,GIE   ;..................................................
ti2_2
			btfss      PIR1,TMR2IF
			goto       ti2_2
			bsf        INTCON,GIE   ;..    TMR2.............

            clrf       TMR0
            bcf        INTCON,T0IF ;   . TMR0
			movlw      b'00000001'
			movwf      T1CON   ; .-1/1, .-osc/4,  TMR1
            return


;---------------------------------------------------------------------------------------




;=======================================================================================
;  -   _256_
;========================================================================================
            
t_256_end__
            movwf      var_temp  ;       TMR0

            btfsc      INTCON,T0IF  ;   TMR0
            bsf        fflags_,0 ;  " "
            
            sublw      2h      ; TMR0 >2 --> error (  )
            btfss      STATUS,C
            bsf        fflags_,0 ;  " "

			clrf       T1CON ;  TMR1 
			bcf        PIR1,CCP1IF  ;  
 
			movf       freq_,w
			subwf      CCPR1L,w
			movwf      freq_   ;......  --> freq_.............
            clrf       freq_+1
            clrf       freq_+2
            clrf       freq_+3 
  
			bsf        STATUS,RP0 ;bank1 
			bcf        PIE1,TMR1IE  ; .  TMR1
			bcf        STATUS,RP0 ;bank0 			
            
            movlw      1h
            movf       CCPR1H,f
            btfss      STATUS,Z
            movwf      CCPR1H    
            btfsc      PIR1,TMR1IF
            movwf      CCPR1H    ; CCPR1H  : 0 - <128 uS, 1 - >128 uS
           
            return

;------------------------------------------------------------------------------------------



;000000000000000000000000000000000000000000000000000000000000000000000000000000000000000





;==============================================================================
;     
;  : butt_flags - 7  - . ., 1 - 1, 0 - 2 
;==============================================================================
button__
			clrf      butt_flags ;   
			btfsc     fflags_,5 ;  2   
			return          ;.    .       

			bsf       STATUS,RP0  ; bank 1
			movlw     0ffh
			bcf       INTCON,GIE  ;  
            movwf     TRISB  ;  
			movwf     TRISA

 			bcf       STATUS,RP0  ; bank 0
            comf      PORTA,w       ;
            andlw     b'00000011'   ;    (1-)
			movwf     butt_flags    ;

			bsf       STATUS,RP0  ; bank 1
			movlw     b'11110000' 
			movwf     TRISA    ; 
			movlw     b'00001000' 
			movwf     TRISB    ; B
            
			bsf       INTCON,GIE  ; . 
			bcf       STATUS,RP0  ; bank 0
			movf      butt_flags,f
			btfss     STATUS,Z    ;   ?(<>0)
			bsf       butt_flags,7 ; . 7-  -   
			return                
;------------------------------------------------------------------------------------




;==============================================================================
;    0.02 - 0.5 
;   pause_,  -  "W"   (P = w*2 mc)
;==============================================================================

pause__                ;  w  10  256,  0.02 - 0.5 . 
			addwf        pause_,w
			movwf        var_pause ;var_pause=pause+w
			  
p_1			movf         pause_,w
			xorwf        var_pause,w ;  pause_ (   TMR0)
			btfss        STATUS,Z ;   pause_= var_pause
			goto         p_1
			return                 

;------------------------------------------------------------------------------			         






      
;====================================================================================
;       7-.   w = .9 max
; ===================================================================================

Table_s__ 
			movwf       PC_temp
            sublw       .9          ;
            btfss       STATUS,C     ;
            retlw       0  ;   w>max.?   --->" "
            movf        PC_temp,w

			movlw       HIGH table_
			movwf       PCLATH
			movf        PC_temp,0
			addlw       LOW table_ 
			btfsc       STATUS,C
			incf        PCLATH,1
			movwf       PCL        ;    PC 
table_                                    ;     W.
            retlw       b'00111111' ; = 0        
            retlw       b'00000110' ; = 1 = 'I'          7-  - 
            retlw       b'01011011' ; = 2                  - 
            retlw       b'01001111' ; = 3                  :
            retlw       b'01100110' ; = 4                 '0123456' 
            retlw       b'01101101' ; = 5 = 'S'            
            retlw       b'01111101' ; = 6                 'abcdefg'
            retlw       b'00000111' ; = 7                                     
            retlw       b'01111111' ; = 8                                     
            retlw       b'01101111' ; = 9                    


;-----------------------------------------------------------------------------------




;======================================================================
;   W*6 . (  )
;======================================================================
delay_Wx6__	
			addlw       -1
			nop
			nop	  
			btfss       STATUS,Z
			goto        delay_Wx6__
			return
;-----------------------------------------------------------------------





;==============================================================================
;                >0.1 .   
;==============================================================================

wait_nobutt__   
				call      button__
				movlw     .5
				call      pause__  ; =10ms
				btfsc     butt_flags,7
				goto      wait_nobutt__ ;    

				movlw     .25
				call      pause__  ; =50ms
				call      button__
				btfsc     butt_flags,7  ;     >0.1 .  
				goto      wait_nobutt__
				return

;-------------------------------------------------------------------------------



;===================================================================================
;              
;     :  W -1 -  , 0 -     (8) .
;===================================================================================
wait_butt__
			movlw     PUSH_BUTT_WAIT ;   X(sec)*10
			movwf     count_
wai_b
			movlw     .50
			call      pause__  ;100ms
			call      button__ 
			btfsc     butt_flags,7
			retlw     1h       ;  w=1,   
			decfsz    count_,1 
			goto      wai_b   ;  PUSH_BUTT_WAIT*100=8(=80)   	  
			retlw     0h 	  ;   8  -     w=0.
;-----------------------------------------------------------------------------------
 



;===================================================================================
;              
;     :  W - 0 -  1- ., 1 -  2- . 2-  
;            W>2 -    
;===================================================================================

push_butt__	  ;    . button__
			movf       butt_flags,w
			andlw      b'00000011'
			addlw      -1         ;  W -   
			return     

;----------------------------------------------------------------------------------









;=====================================================================================
;         
;   regime_. : 0- , 1- ., 2-,
;                          3-. . ., 4-. . ., 5--FTt1t0
;=====================================================================================



regime__    
            clrf      fflags_    ;   

         	movf      regime_,w
			movwf     reg_temp   ;  regime_ 

r_			call      ind_re__

			call      wait_nobutt__

			call      wait_butt__
			xorlw     0h
			btfsc     STATUS,Z
			goto      end_re  ;   8  -   

			call      push_butt__ ;  ,  
			xorlw     0h
			btfsc     STATUS,Z
			goto      r_3      ; 1- -   
			xorlw     1h
			btfss     STATUS,Z
			goto      r_      ;     -  

			movf      regime_,w   ;   2-  
			movwf     reg_temp   ;  reg_temp
		
			clrw
			call      out_word__   ;W=0       "--YES-- "
			call      wait_nobutt__ ; 
			goto      end_re
			     
r_3		
			movlw     .1
			bcf       STATUS,C
			rlf       regime_,1   ; regime_
			btfsc     regime_,5   ; 
			movwf     regime_     ;-->0..4,0.. 

			goto      r_

end_re		movf      reg_temp,w
			movwf     regime_    ;  

            movlw     8h
            call      out_word__ ;   .  "-COUNt--"

			return



;--------------------------------------------------------------------------------------





;======================================================================================
;      
;     - regime_
;======================================================================================
ind_re__
			btfsc   regime_,0
			movlw   1h    
			btfsc   regime_,1
			movlw   2h    
			btfsc   regime_,2
			movlw   3h     
			btfsc   regime_,3
			movlw   4h
			btfsc   regime_,4
			movlw   5h ;     .....................

			call    out_word__ ;   . . 
			return

;--------------------------------------------------------------------------------------





      
;====================================================================================
;      . w = .47 max
; ===================================================================================

tab_word__ 
			movwf       PC_temp
			movlw       HIGH t_word
			movwf       PCLATH
			movf        PC_temp,0
			addlw       LOW t_word 
			btfsc       STATUS,C
			incf        PCLATH,1
			movwf       PCL        ;    PC 
t_word                             ;     W.

            retlw       _MIDDLE   
            retlw       _MIDDLE 
            retlw       _Y 
            retlw       _E       
            retlw       _S 
            retlw       _MIDDLE        
            retlw       _MIDDLE 
            retlw       _SPACE  ; '--YES-- ' -0
            retlw       _F 
            retlw       _r        
            retlw       _E       
            retlw       _q 
            retlw       _BOTTOM
            retlw       _BOTTOM    
            retlw       _S 
            retlw       _t      ; 'FrEq__St' -1       
            retlw       _F 
            retlw       _r        
            retlw       _E        
            retlw       _q 
            retlw       _BOTTOM 
            retlw       _BOTTOM        
            retlw       _S 
            retlw       _P      ; 'FrEq__SP'  -2      
            retlw       _P  
            retlw       _E  
            retlw       _r  
            retlw       _I        
            retlw       _O        
            retlw       _d  
            retlw       _SPACE  
            retlw       _SPACE  ; 'PErIOd  '  -3      
            retlw       _t 
            retlw       _SPACE        
            retlw       _BOTTOM 
            retlw       _BOTTOM 
            retlw       _N 
            retlw       _BOTTOM        
            retlw       _BOTTOM
            retlw       _SPACE  ; 't ____ '  -4
            retlw       _t 
            retlw       _SPACE        
            retlw       _UP  
            retlw       _UP         
            retlw       _U 
            retlw       _UP  
            retlw       _UP  
            retlw       _SPACE  ; 't ``U`` '  -5     
            retlw       _MIDDLE
            retlw       _H
            retlw       _E
            retlw       _L        
            retlw       _L        
            retlw       _O  
            retlw       _MIDDLE 
            retlw       _SPACE  ; '-HELLO- '  -6      
            retlw       _SPACE  
            retlw       _SPACE
            retlw       _N        
            retlw       _O        
            retlw       _BOTTOM  
            retlw       _S 
            retlw       _I        
            retlw       _G      ; '  NO_SIG'  -7      
            retlw       _MIDDLE
            retlw       _C        
            retlw       _O        
            retlw       _U  
            retlw       _N 
            retlw       _t        
            retlw       _MIDDLE
            retlw       _MIDDLE ; '-COUNt--'  -8      
            retlw       _F
            retlw       _BOTTOM
            retlw       _t
            retlw       _O        
            retlw       _O        
            retlw       _BOTTOM  
            retlw       _H 
            retlw       _I      ; 'F_tOO_HI'  -9      
            retlw       _F
            retlw       _P
            retlw       _t
            retlw       _MIDDLE        
            retlw       _t        
            retlw       _E  
            retlw       _S 
            retlw       _t      ; 'FPt-tESt'  -10      
          

;-------------------------------------------------------------------------------------- 




;======================================================================================
;    (8 )    
;   W -     
;======================================================================================
out_word__
			movwf       var_temp
			bcf         STATUS,C
			rlf         var_temp,f
			rlf         var_temp,f
			rlf         var_temp,f ; *8 = .  1- 
			movlw       8h
			movwf       count_  ;  8- 
			addwf       var_temp,f ; 1-  + 8
			movlw       LED_OUT+7
			movwf       FSR     ;   
ow_1
			movf        count_,w
			subwf       var_temp,w ;  .   
			call        tab_word__ ;   
			movwf       INDF       ;    
			decf        FSR,f
			decfsz      count_,f   ;   8 ?
			goto        ow_1       

			return


;-----------------------------------------------------------------------------------



;===================================================================================
;    4-    BCD
; : 4-.  freq_, out_bcd  -  . - .  
; 1871 
;===================================================================================
b2bcd__
			movlw	.32		; 4  - 32-
			movwf	count_		 
			clrf	out_bcd		
			clrf	out_bcd+1
			clrf	out_bcd+2
			clrf	out_bcd+3   ;   BCD
	
b2bcd2
			movlw	out_bcd		
			movwf	FSR
			movlw	4h
			movwf	temp ;  . 

b2bcd3  		        ;  
			movlw	33h		
			addwf	INDF,f		;   
			btfsc	INDF,3		;  7 ?
			andlw	0f0h		;  . . 
			btfsc	INDF,7		; .  >7 ?
			andlw	0fh	 	  	;  . .
			subwf	INDF,f		;   
			incf	FSR,f		;  
			decfsz	temp,f
			goto	b2bcd3
	
			rlf	freq_+0,f 	; . 
			rlf freq_+1,f
			rlf freq_+2,f
			rlf	freq_+3,f
			rlf	out_bcd+0,f	; --> BCD
			rlf	out_bcd+1,f
			rlf	out_bcd+2,f
			rlf	out_bcd+3,f

			decfsz	count_,f		; ?
			goto	b2bcd2	
			return			;

;----------------------------------------------------------------------------------


;======================================================================================
;      bcd-     
;  :  W -  .    (0-7) W=0 or W>7 - . 
;======================================================================================
outBCD__
			bcf        INTCON,GIE   ;..................................................
obcd_0
			btfss      PIR1,TMR2IF
			goto       obcd_0
			bsf        INTCON,GIE   ;..    TMR2.............

			movwf     temp  ;  . 
						  ; .......  . ...........
			sublw     7h
			btfss     STATUS,C
			clrf      temp  ; W>7 --->W=0
			movf      temp,w

			clrf      temp+1
			decf      temp+1,f ; =ffh
obcd_2
			bcf       STATUS,C
			rlf       temp+1,f
			addlw     -1
			btfsc     STATUS,C
			goto      obcd_2     ;  :  . . . ,  -1

			
			movlw	LED_OUT+7
			movwf	freq_+1		;  
			movlw	out_bcd+3
			movwf	freq_+2		;  bcd 
			movlw	4h		; 4 
			movwf	count_
obcd_3
			movf	freq_+2,w	;   
			movwf	FSR
			decf	freq_+2,f	; . .   
			movf	INDF,w		;  2 bcd
			movwf	freq_		; 
			movf	freq_+1,w	;    
			movwf	FSR
			decf	freq_+1,f	; 
			decf	freq_+1,f   ; . --> -2 
			swapf	freq_,w		; 
			andlw	0fh         ; .  .    
			btfss   STATUS,Z    ;=0?
			clrf    temp+1      ;  <>0 -->    
			call    Table_s__   ; 
			btfsc   temp+1,7
			movlw   _SPACE      ;   
			movwf	INDF		;  
			bcf     STATUS,C
			rlf     temp+1,f    ;   . .

			decf	FSR,f
			movf	freq_,w		; 
			andlw	0fh	 		;  . 
			btfss   STATUS,Z
			clrf    temp+1    ;  <>0 -->    
			call    Table_s__   ; 
			btfsc   temp+1,7    ;...... 7-  =1 - .  ( )......
			movlw   _SPACE      ;   
			movwf	INDF		;  
			bcf     STATUS,C
			rlf     temp+1,f    ;   . .

			decfsz	count_,f	;  ?
			goto	obcd_3
	
                           ;................. ....................... 
			movf      temp,f 
			btfsc     STATUS,Z   ;  
			return
			movlw     LED_OUT
			addwf     temp,w
			movwf     FSR
			bsf       INDF,7     ;  ,   - .  7
			return
			
;---------------------------------------------------------------------------------------


;=======================================================================================
;     1/,   . 1000000000/
;   ,        .
; : out_bcd -  (1000000000), freq_ -, temp -  
;            (  , 1-  - . ),  -  freq_
; : 0 -   , 1 -         
;========================================================================================

DIVIDE_1byX__

        ; Test for zero division
        movf    freq_,w
        iorwf   freq_+1,w
        iorwf   freq_+2,w
        btfsc   STATUS,Z
        retlw   0x00    ; divisor = zero, not possible to calculate return with zero in w



        movlw   3bh
        movwf   out_bcd+3
        movlw   9ah
        movwf   out_bcd+2
        movlw   0cah
        movwf   out_bcd+1
        clrf    out_bcd     ;   out_bcd  1000.000.000 (0x3B9ACA00)

                   ;  ,  x/y  (x+y/2)/y       
        bcf     STATUS,C   ;
        rrf     freq_+2,w  ;
        movwf   temp+2     ;
        rrf     freq_+1,w  ;
        movwf   temp+1     ;
        rrf     freq_,w    ;
        movwf   temp       ; freq_/2 ---> temp

        movf    temp,w        ; out_bcd = 1000000000+freq_/2 ...................
        addwf   out_bcd,f        
        movf    temp+1,w     
        btfsc   STATUS,C      
        incfsz  temp+1,w     
        addwf   out_bcd+1,f        
        movf    temp+2,w       
        btfsc   STATUS,C       
        incfsz  temp+2,w
        addwf   out_bcd+2,f 
        btfsc   STATUS,C       
        incf    out_bcd+3,f    ;............................................... 
                    

        call    DEVIDE_32to24__ ;  (1000000000+freq_/2)/freq_

        movf    out_bcd,w
        movwf   freq_
        movf    out_bcd+1,w
        movwf   freq_+1
        movf    out_bcd+2,w
        movwf   freq_+2
        movf    out_bcd+3,w
        movwf   freq_+3       ;  ----> freq_

        retlw   1    ; done

;---------------------------------------------------------------------------------------
   




;=======================================================================================
;    4-  (out_bcd)  3-  (freq_)
;  temp - 4-  
;   - out_bcd,  - temp
;=======================================================================================
DEVIDE_32to24__

        ; prepare used variables
        clrf    temp
        clrf    temp+1
        clrf    temp+2
        clrf    temp+3

        movlw  .32     ;MOVLW   D'48'           ; initialize bit counter
        movwf   count_

DIVIDE_LOOP_48by24
        rlf     out_bcd,f
        rlf     out_bcd+1,f
        rlf     out_bcd+2,f
        rlf     out_bcd+3,f
        ; shift in highest bit from dividend through carry in temp
        rlf     temp,f
        rlf     temp+1,f
        rlf     temp+2,f

        rlf     temp+3, f

        movf    freq_,w     ; get LSB of divisor
        btfsc   temp+3, 7
        goto    Div48by24_add

        ; subtract 24 bit divisor from 24 bit temp
        subwf   temp,f        ; subtract

        movf    freq_+1,w     ; get middle byte
        btfss   STATUS,C        ;  if overflow ( from prev. subtraction )
        incfsz  freq_+1,w     ; incresase source
        subwf   temp+1,f        ; and subtract from dest.

        movf    freq_+2,w       ; get top byte
        btfss   STATUS,C        ;  if overflow ( from prev. subtraction )
        incfsz  freq_+2,w       ; increase source
        subwf   temp+2,f          ; and subtract from dest.

        movlw   1
        btfss   STATUS,C
        subwf   temp+3, f
        goto    DIVIDE_SKIP_48by24 ; carry was set, subtraction ok, continue with next bit 

Div48by24_add
        ; result of subtraction was negative restore temp
        addwf   temp,f        ; add it to the lsb of temp

        movf    freq_+1,w     ; middle byte
        btfsc   STATUS,C        ; check carry for overflow from previous addition
        incfsz  freq_+1,w     ; if carry set we add 1 to the source
        addwf   temp+1,f        ; and add it if not zero in that case Product+Multipland=Product

        movf    freq_+2,w       ; MSB byte
        btfsc   STATUS,C        ; check carry for overflow from previous addition
        incfsz  freq_+2,w
        addwf   temp+2,f          ; handle overflow

        movlw   1
        btfsc   STATUS,C
        addwf   temp+3, f

DIVIDE_SKIP_48by24
        decfsz  count_,f      ; decrement loop counter
        goto    DIVIDE_LOOP_48by24      ; another run
        ; finally shift in the last carry
        rlf     out_bcd,f
        rlf     out_bcd+1,f
        rlf     out_bcd+2,f
        rlf     out_bcd+3,f

        return 
;----------------------------------------------------------------------------------------



                                  




			end



 
